Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.toplink.support
Class TransactionAwareSessionAdapter

    java.lang.Object
      org.springframework.orm.toplink.support.TransactionAwareSessionAdapter

All Implemented Interfaces:
  FactoryBean

    public class TransactionAwareSessionAdapter

extends Object
implements FactoryBean

This adapter FactoryBean takes a TopLink SessionFactory and exposes a corresponding transaction-aware TopLink Session as bean reference.

This adapter bean will usually be defined in front of a Spring LocalSessionFactoryBean, to allow for passing Session references to DAOs that expect to work on a raw TopLink Session. Your DAOs can then, for example, access the currently active Session and UnitOfWork via `Session.getActiveSession()` and `Session.getActiveUnitOfWork()`, respectively.

The main advantage of this proxy is that it allows DAOs to work with a plain TopLink Session reference, while still participating in Spring's (or a J2EE server's) resource and transaction management. DAOs will only rely on the TopLink API in such a scenario, without any Spring dependencies.

It is usually preferable to write your TopLink-based DAOs with Spring's TopLinkTemplate, offering benefits such as consistent data access exceptions instead of TopLinkExceptions at the DAO layer. However, Spring's resource and transaction management (and Dependency Injection) will work for DAOs written against the plain TopLink API too.

Of course, you can still access the target TopLink SessionFactory even when your DAOs go through this adapter, by defining a bean reference that points directly at your target SessionFactory bean.

Note that the actual creation of a transaction-aware TopLink Session is available on the TopLink SessionFactory itself. This adapter FactoryBean is just a convenient way to expose such a Session in a declarative fashion.

Since:
  1.2
Author:
  Juergen Hoeller
See Also:
  `LocalSessionFactoryBean`, `SessionFactory.createTransactionAwareSession()`, `Session.getActiveSession()`, `Session.getActiveUnitOfWork()`

Constructor Summary
`TransactionAwareSessionAdapter()`

Method Summary
`Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton?
`void` | `setSessionFactory(SessionFactory sessionFactory)` Set the SessionFactory that this adapter is supposed to expose a transaction-aware TopLink Session for.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TransactionAwareSessionAdapter

    public TransactionAwareSessionAdapter()

Method Detail

### setSessionFactory

    public void setSessionFactory(SessionFactory sessionFactory)

  Set the SessionFactory that this adapter is supposed to expose a transaction-aware TopLink Session for. This should be the raw SessionFactory, as accessed by TopLinkTransactionManager.

  See Also:
    `TopLinkTransactionManager`

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.